;--------------------------------------------------------------------------------------------------
;	Console Prog to examine HIDs
;       Roger Stone April 2009
;
;Assemblewith:-	GoAsm USBtest.asm
;Link with:-	GoLink /console Kernel32.dll hid.dll setupapi.dll USBtest.obj -DEBUG COFF
;--------------------------------------------------------------------------------------------------

#include \GoAsm\Include\windows.inc

;--------------------------------------------------------------------------------------------------
DATA SECTION
Startstrg db 0ch,"USBtestC",13,10,13,10
Errorstrg db 00eh,"Error time!",13,10
Donestrg  db 00bh,13,10,"No more",13,10
goodstrg  db 00bh,13,10,"HID found"
wrongstrg  db 00ch," - not Valid",13,10
Endstrg   db 012h,13,10,"That's all Folks"

HIDGuid			GUID 

SP_DEVICE_INTERFACE_DATA STRUCT
cbSize			DD	;SIZEOF SP_DEVICE_INTERFACE_DATA STRUCT
InferfaceClassGuid	GUID
Flags			DD
Reserved		DD
ENDSTRUCT

DevIntData		SP_DEVICE_INTERFACE_DATA
hDevInfoSet		DD ?
hStdOut			DD ?
numchars		DD ?
hHeap			DD ?
index			DD ?
length			DD ?
HIDpntr			DD ?
detaildatapntr		DD ?
;--------------------------------------------------------------------------------------------------

CODE SECTION
START:
	
		mov eax, offset Startstrg
		call OutStrg 

			;--------------------------<  Obtain the GUID for the HID class >--------------------------
		mov eax, offset HIDGuid
		invoke HidD_GetHidGuid, eax	

			;------------------< Get device information set about all  HID devices  >------------------
		mov eax, offset HIDGuid
		invoke SetupDiGetClassDevsA, eax, 0, 0, 012h 	; returns handle to device info set

		cmp eax, INVALID_HANDLE_VALUE	; zero if no result 
		jz >error
		mov [hDevInfoSet], eax		; save handle to info set

			;-------------------------<Get info about one device in the set >--------------------------
		mov D [index], 0
		mov eax, SIZEOF DevIntData
		mov [DevIntData.cbSize], eax
		mov eax, offset HIDGuid
		mov [HIDpntr], eax

a2:
		invoke SetupDiEnumDeviceInterfaces, [hDevInfoSet], 0, [HIDpntr], [index], offset DevIntData	

		or eax,eax
		jnz >a3
		mov eax, offset Donestrg
		call OutStrg 
		jmp long >alldone
		;----------
a3:
		mov eax, offset goodstrg
		call OutStrg 
			;--------------------------------< Get the size of the details >---------------------------
		invoke SetupDiGetDeviceInterfaceDetailA, [hDevInfoSet], offset DevIntData, 0, 0, offset length, 0

			;------------------------------< Make some space for the details >-------------------------
		invoke HeapCreate, 0, 0, 0
		or eax,eax
		jz >error
		mov [hHeap], eax		; save handle to heap

		invoke HeapAlloc, eax, HEAP_ZERO_MEMORY, [length]
		or eax,eax
		jz >error
		mov [detaildatapntr], eax
			;------------------------------------< Get the details >-----------------------------------
		mov eax,[length]
		add eax, 6
		mov edx, [detaildatapntr]
		mov [edx],eax
	
		invoke SetupDiGetDeviceInterfaceDetailA, [hDevInfoSet], offset DevIntData, [detaildatapntr], [length], offset length, 0

		or eax,eax			; returns 0 if fail
		jnz >a5

		mov eax, offset wrongstrg
		call OutStrg

		push [hHeap]
		call HeapDestroy

a5:		inc d [index]			; next HID in set
		jmp long a2
		;----------
error:		mov eax, offset Errorstrg
		call OutStrg 
alldone:
		mov eax, offset Endstrg
		call OutStrg 
		invoke ExitProcess, 0

;------------------------------------------------------------------------------------------------------------------
OutStrg: 
 	push 0
	push offset numchars		; bytes written
	movzx edx,b [eax]
	inc eax
	push edx			; number of chars
	push eax			; adress of string
	push STD_OUTPUT_HANDLE
	call GetStdHandle
	push eax
	call WriteFile
	ret
;------------------------------------------------------------------------------------------------------------------

